diff -Nru WRFV3.5/chem/chem_driver.F WRFV3.5_MR/chem/chem_driver.F
--- WRFV3.5/chem/chem_driver.F	2013-03-22 20:32:12.000000000 +0100
+++ WRFV3.5_MR/chem/chem_driver.F	2014-12-17 11:53:55.938794000 +0100
@@ -972,7 +972,14 @@
 
               ids,ide, jds,jde, kds,kde,                                                   &
               ims,ime, jms,jme, kms,kme,                                                   &
-              its,ite,jts,jte,kts,kte)
+!cmr              its,ite,jts,jte,kts,kte)
+              its,ite,jts,jte,kts,kte,                                                     &
+              fco2=grid%fco2,fco2mn=grid%fco2mn,fco2mx=grid%fco2mx,                        &
+              fco2nf=grid%fco2nf,co2_clm=grid%co2_clm,                                     &
+              co2_clm2=grid%co2_clm2,co2_clm3=grid%co2_clm3     )
+!cmr end
+
+
               if( config_flags%chem_opt == MOZART_KPP .or. &
                   config_flags%chem_opt == MOZCART_KPP .or. &
                   config_flags%chem_opt == MOZART_MOSAIC_4BIN_VBS0_KPP ) then
diff -Nru WRFV3.5/chem/chemics_init.F WRFV3.5_MR/chem/chemics_init.F
--- WRFV3.5/chem/chemics_init.F	2013-03-15 21:25:43.000000000 +0100
+++ WRFV3.5_MR/chem/chemics_init.F	2014-12-17 11:53:55.997748000 +0100
@@ -306,20 +306,21 @@
 !   ENDIF
 
     CALL nl_get_mminlu( 1, mminlu_loc )
-
-    IF (trim(mminlu_loc) /= 'USGS' .and. trim(mminlu_loc) /= 'MODIFIED_IGBP_MODIS_NOAH' ) THEN
-      print*,mminlu_loc
-      message_txt = " ERROR: CHEM_INIT: Chemistry routines require USGS or MODIS_NOAH land use maps. Need to change land use option."
-      call wrf_error_fatal( trim(message_txt) )
-    ELSE
-      IF (trim(mminlu_loc) == 'USGS' .and. grid%num_land_cat /= 24 ) THEN
-        message_txt = " ERROR: CHEM_INIT: USGS land use map should have 24 catagories."
-        call wrf_error_fatal( trim(message_txt) )
-      ELSEIF (trim(mminlu_loc) == 'MODIFIED_IGBP_MODIS_NOAH' .and. grid%num_land_cat /= 20 ) THEN
-        message_txt = " ERROR: CHEM_INIT: MODIS_NOAH land use map should have 20 catagories."
-        call wrf_error_fatal( trim(message_txt) )
-      ENDIF
-    ENDIF
+!cmr begin
+!    IF (trim(mminlu_loc) /= 'USGS' .and. trim(mminlu_loc) /= 'MODIFIED_IGBP_MODIS_NOAH' ) THEN
+!      print*,mminlu_loc
+!      message_txt = " ERROR: CHEM_INIT: Chemistry routines require USGS or MODIS_NOAH land use maps. Need to change land use option."
+!      call wrf_error_fatal( trim(message_txt) )
+!    ELSE
+!      IF (trim(mminlu_loc) == 'USGS' .and. grid%num_land_cat /= 24 ) THEN
+!        message_txt = " ERROR: CHEM_INIT: USGS land use map should have 24 catagories."
+!        call wrf_error_fatal( trim(message_txt) )
+!      ELSEIF (trim(mminlu_loc) == 'MODIFIED_IGBP_MODIS_NOAH' .and. grid%num_land_cat /= 20 ) THEN
+!        message_txt = " ERROR: CHEM_INIT: MODIS_NOAH land use map should have 20 catagories."
+!        call wrf_error_fatal( trim(message_txt) )
+!      ENDIF
+!    ENDIF
+     print*,'!cmr: skipping fatal error for debugging: "ERROR: CHEM_INIT: Chemistry routines require USGS or MODIS_NOAH land use maps. Need to change land use option."'
 !--
 
     if( .NOT. config_flags%restart ) then
@@ -416,6 +417,19 @@
      call VPRM_par_initialize ( grid%rad_vprm, grid%lambda_vprm, grid%alpha_vprm, grid%resp_vprm, config_flags )
      call wrf_message("Warning: the VPRM parameters may need to be optimized depending on the season, year and region!")
      call wrf_message("The parameters provided here should be used for testing purposes only!")
+!cmr - initialize CO2 tracers:
+       do j=jts,jte
+        do k=kts,kte
+         do i=its,ite
+            chem(i,k,j,p_co2_bck)=config_flags%valley_CO2backgr  ! background CO2 tracer
+            chem(i,k,j,p_co2_bio)=config_flags%valley_CO2backgr  ! A user should subtract this from the output fields!
+            chem(i,k,j,p_co2_oce)=config_flags%valley_CO2backgr   ! A user should subtract this from the output fields!
+            chem(i,k,j,p_co2_ant)=config_flags%valley_CO2backgr   ! A user should subtract this from the output fields!
+            chem(i,k,j,p_co2_tst)=config_flags%valley_CO2backgr   ! A user should subtract this from the output fields!
+         enddo
+        enddo
+       enddo
+!cmr end
 end if
 ! Read parameters for the termite model and put them into wrfinput file
 if (config_flags%chem_opt .EQ. GHG_TRACER) then
diff -Nru WRFV3.5/chem/emissions_driver.F WRFV3.5_MR/chem/emissions_driver.F
--- WRFV3.5/chem/emissions_driver.F	2013-03-22 20:32:12.000000000 +0100
+++ WRFV3.5_MR/chem/emissions_driver.F	2014-12-17 11:53:55.959404000 +0100
@@ -66,7 +66,11 @@
 
          ids,ide, jds,jde, kds,kde,                                        &
          ims,ime, jms,jme, kms,kme,                                        &
-         its,ite, jts,jte, kts,kte                                         )
+!cmr begin        its,ite, jts,jte, kts,kte                                         )
+         its,ite, jts,jte, kts,kte,                                        &
+         fco2,fco2mn,fco2mx,fco2nf,co2_clm,co2_clm2,co2_clm3              )
+!cmr end
+
 !----------------------------------------------------------------------
   USE module_configure
   USE module_state_description
@@ -289,6 +293,10 @@
      REAL, DIMENSION( ims:ime, kms:kme, jms:jme ),           INTENT(IN   ) :: refl_10cm
 ! end stuff for lightning NOx
 !
+!cmr define CO2 flux variable
+      real, dimension(ims:ime,jms:jme),intent(inout) :: fco2,fco2mn,fco2mx,fco2nf 
+      real, dimension(ims:ime,kms:kme,jms:jme),intent(inout) :: co2_clm,co2_clm2,co2_clm3 
+!cmr end
 ! Local variables...
 !
       INTEGER :: begday,endday,i, j, k, ksub, dust_emiss_active, seasalt_emiss_active,emiss_ash_hgt
@@ -987,7 +995,10 @@
                             its,ite, jts,jte, kts,kte,          &
 
                             dtstep,dz8w,config_flags,rho_phy,   &
-                            chem,emis_ant,eghg_bio,ebio_co2oce  )
+!cmr begin                  chem,emis_ant,eghg_bio,ebio_co2oce  )
+                            chem,emis_ant,eghg_bio,ebio_co2oce, &
+                            fco2,fco2mn,fco2mx,fco2nf,co2_clm,co2_clm2,co2_clm3,swdown)
+!cmr end
    END IF
 !**************************************************************************************************
     CASE (SAPRC99_KPP) !FIX FOR SAPRC07A
diff -Nru WRFV3.5/chem/module_ghg_fluxes.F WRFV3.5_MR/chem/module_ghg_fluxes.F
--- WRFV3.5/chem/module_ghg_fluxes.F	2012-07-27 21:07:12.000000000 +0200
+++ WRFV3.5_MR/chem/module_ghg_fluxes.F	2014-12-17 11:53:55.974718000 +0100
@@ -44,7 +44,9 @@
                              its,ite, jts,jte, kts,kte,             &     ! Tile dimensions
                                                                     
                              dtstep, dz8w, config_flags, rho_phy,   &
-                             chem, emis_ant,eghg_bio,ebio_co2oce    )
+!cmr                             chem, emis_ant,eghg_bio,ebio_co2oce    )
+                             chem, emis_ant,eghg_bio,ebio_co2oce,   &
+                             fco2,fco2mn,fco2mx,fco2nf,co2_clm,co2_clm2,co2_clm3,swrad )
 
 ! March-28, this subroutine adds all type of greenhouse gases to the chem species
 
@@ -63,6 +65,13 @@
 REAL, DIMENSION( ims:ime, kms:kme, jms:jme ), INTENT(IN ) ::   rho_phy, dz8w
 REAL, DIMENSION( ims:ime, kms:config_flags%kemit, jms:jme, num_emis_ant ), INTENT(IN ) :: emis_ant
 REAL, DIMENSION( ims:ime, 1,jms:jme, num_eghg_bio ), INTENT(IN ) :: eghg_bio
+!cmr define CO2 net flux variable
+real, dimension(ims:ime,jms:jme),intent(IN) :: fco2,fco2mn,fco2mx,fco2nf
+REAL, DIMENSION( ims:ime, kms:kme, jms:jme), INTENT(INOUT ) :: co2_clm,co2_clm2,co2_clm3
+REAL, DIMENSION (ims:ime, jms:jme), INTENT(IN)    :: swrad
+REAL    :: valley_CO2antr
+!cmr
+
 
 INTEGER :: i,j,k
 REAL    :: conv_rho
@@ -73,22 +82,36 @@
 DO j=jts,jte
    DO i=its,ite
       !  3D anthropogenic fluxes
-      DO k=kts,min(config_flags%kemit,kte)
-         conv_rho=8.0461e-6/rho_phy(i,k,j)*dtstep/dz8w(i,k,j)  ! 8.0461e-6=molar_mass(air)/3600, [g/mol/s]
-         chem(i,k,j,p_co2_ant)= chem(i,k,j,p_co2_ant) + conv_rho* emis_ant(i,k,j,p_e_co2)
-         chem(i,k,j,p_co2_tst)= chem(i,k,j,p_co2_tst) + conv_rho* emis_ant(i,k,j,p_e_co2tst)
-         chem(i,k,j,p_co_ant) = chem(i,k,j,p_co_ant)  + conv_rho* emis_ant(i,k,j,p_e_co)
+!cmr      DO k=kts,min(config_flags%kemit,kte)
+         k = 1
+!          conv_rho=8.0461e-6/rho_phy(i,k,j)*dtstep/dz8w(i,k,j)  ! 8.0461e-6=molar_mass(air)/3600, [g/mol/s]
+         conv_rho=44.e-3/rho_phy(i,k,j)*dtstep/dz8w(i,k,j) ! conversion from [mmol/m^2/s]to ppmv
+!         chem(i,k,j,p_co2_ant)= chem(i,k,j,p_co2_ant) + conv_rho* emis_ant(i,k,j,p_e_co2)
+!         chem(i,k,j,p_co2_tst)= chem(i,k,j,p_co2_tst) + conv_rho* emis_ant(i,k,j,p_e_co2tst)
+!         chem(i,k,j,p_co_ant) = chem(i,k,j,p_co_ant)  + conv_rho* emis_ant(i,k,j,p_e_co)
 
       ! 2D biospheric fluxes:
-      if (k==1) then
-         chem(i,1,j,p_co2_bio)= chem(i,1,j,p_co2_bio) + conv_rho* (eghg_bio(i,1,j,p_ebio_gee) + eghg_bio(i,1,j,p_ebio_res))   ! both uptake and release
-         chem(i,1,j,p_co2_oce)= chem(i,1,j,p_co2_oce) + conv_rho* ebio_co2oce(i,j)
-      end if
-
-      ENDDO
+!cmr  add net CO2 flux here  
+         chem(i,1,j,p_co2_bio) = chem(i,1,j,p_co2_bio) + conv_rho*fco2(i,j)
+         chem(i,1,j,p_co2_ant) = chem(i,1,j,p_co2_ant) + conv_rho*fco2mn(i,j)
+         chem(i,1,j,p_co2_oce) = chem(i,1,j,p_co2_oce) + conv_rho*fco2mx(i,j)
+         chem(i,1,j,p_co2_bck) = chem(i,1,j,p_co2_bck) + conv_rho*fco2nf(i,j)
+!cmr  adding anthropogenic CO2 flux in valley centre here  
+!      valley_CO2antr = 50.
+!      if ( (j .eq. 20) .and. (maxval(swrad) .gt. 1.) ) then
+!         chem(i,1,j,p_co2_ant)= chem(i,1,j,p_co2_ant) + conv_rho*valley_CO2antr
+!      end if
+!      ENDDO
    ENDDO
 ENDDO
 
+!cmr copy co2_bio field on co2_clm
+co2_clm(:,:,:) = chem(:,:,:,p_co2_bio)
+co2_clm2(:,:,:) = chem(:,:,:,p_co2_ant)
+co2_clm3(:,:,:) = chem(:,:,:,p_co2_oce)
+!cmr
+
+
 ! For the GHG_TRACER option only
 IF(config_flags%chem_opt==GHG_TRACER) THEN
     DO j=jts,jte
diff -Nru WRFV3.5/dyn_em/module_big_step_utilities_em.F WRFV3.5_MR/dyn_em/module_big_step_utilities_em.F
--- WRFV3.5/dyn_em/module_big_step_utilities_em.F	2013-04-01 16:53:17.000000000 +0200
+++ WRFV3.5_MR/dyn_em/module_big_step_utilities_em.F	2014-12-17 11:53:56.028518000 +0100
@@ -4804,11 +4804,13 @@
     k_start = kts
     k_end = min( kte, kde-1 )
 !jdf
-    do j = j_start,j_end
-    do i = i_start, i_end
-      if(landmask(i,j).lt.0.5) xland(i,j)=2.0
-    enddo
-    enddo
+!cmr uncomment to keep xland to 1
+!    do j = j_start,j_end
+!    do i = i_start, i_end
+!      if(landmask(i,j).lt.0.5) xland(i,j)=2.0
+!    enddo
+!    enddo
+!cmr
 !jdf
 
 !  compute thermodynamics and velocities at pressure points (or half levels)
diff -Nru WRFV3.5/dyn_em/module_first_rk_step_part1.F WRFV3.5_MR/dyn_em/module_first_rk_step_part1.F
--- WRFV3.5/dyn_em/module_first_rk_step_part1.F	2013-03-22 20:30:26.000000000 +0100
+++ WRFV3.5_MR/dyn_em/module_first_rk_step_part1.F	2014-12-17 11:53:56.041947000 +0100
@@ -116,6 +116,7 @@
     INTEGER, INTENT(IN)                           ::  k_start, k_end
     LOGICAL, INTENT(IN), OPTIONAL                 ::  f_flux
 
+!    real,  dimension(ims:ime,jms:jme ) :: fco2!cmr
 ! Local
     real :: HYDRO_dt
     REAL, DIMENSION( ims:ime, jms:jme ) :: exch_temf  ! 1/7/09 WA
@@ -401,7 +402,8 @@
           HYDRO_dt = -1
       endif
 
-      CALL surface_driver(                                                &
+      CALL surface_driver(                                                
+!cmr     &         cf1=grid%cf1, cf2=grid%cf2, cf3=grid%cf3,                  &
      &        HYDRO_dt=HYDRO_dt,  sfcheadrt=grid%sfcheadrt,               &
      &        INFXSRT=grid%INFXSRT,  soldrain=grid%soldrain,              &
      &         ACGRDFLX=grid%acgrdflx  ,ACHFX=grid%achfx        ,ACLHF=grid%aclhf        &
@@ -692,7 +694,20 @@
      &        , okms = 1, okme=config_flags%ocean_levels                  & ! cyl:3DPWP
      &        ,rdx=grid%rdx, rdy=grid%rdy,msfu=grid%msfu,msfv=grid%msfv,msft=grid%msft &!cyl: 3DPWP
      &        ,XTIME=grid%xtime,OM_TINI=grid%om_tini,OM_SINI=grid%om_sini,id=grid%id,omdt=config_flags%omdt &!cyl: 3DPWP 
-     &                                                              )
+     &        ,fco2=grid%fco2,fco2mn=grid%fco2mn,fco2mx=grid%fco2mx,fco2nf=grid%fco2nf,reco=grid%reco,reco_gpp=grid%reco_gpp & 
+     &        ,reco_gppmn=grid%reco_gppmn,reco_gppmx=grid%reco_gppmx,fpsn=grid%fpsn,fpsn_mn=grid%fpsn_mn, & !cmr
+     &         fpsn_mx=grid%fpsn_mx,fpsn_nf=grid%fpsn_nf,fpsn_noslp=grid%fpsn_noslp & !cmr
+     &        ,co2_clm=grid%co2_clm,co2_clm2=grid%co2_clm2,co2_clm3=grid%co2_clm3,wj=grid%wj,we=grid%we,wc=grid%wc  & !cmr
+     &        ,ci_mr=grid%ci_mr,rs_mr=grid%rs_mr,rb_mr=grid%rb_mr,btran_mr=grid%btran_mr,apar_mr=grid%apar_mr & !cmr 
+     &        ,sla_mr=grid%sla_mr,vcmx_mr=grid%vcmx_mr,svpts_mr=grid%svpts_mr,eah_mr=grid%eah_mr  & !cmr
+     &        ,valley_CO2pft2=config_flags%valley_CO2pft2,valley_CO2backgr=config_flags%valley_CO2backgr & !cmr
+     &           )
+!cmr
+!   write(message,*) 'shape(grid%fpsnco2) = ',shape(grid%fpsnco2),'maxval',maxval(grid%fpsnco2) 
+!   CALL wrf_debug(0,message)
+!   write(message,*) 'shape(grid%xland) =',shape(grid%xland),'xland(20,20)',grid%xland(20,20)
+!   CALL wrf_debug(0,message)
+!cmr end
 
 #ifdef WRF_HYDRO
         if(HYDRO_dt .gt. 1 ) call wrf_drv_HYDRO(HYDRO_dt, grid,  &
